require 'rspec'
require 'gotham_dice'

describe GothamDice do
  subject { described_class.get }
  it { is_expected.to be_a described_class }
  it { expect(subject.dice.keys.count).to eq 6 }
  it { expect(subject.dice.values.all? { |d| d.is_a? ParaDice::StringDie }).to be true }
  it { expect(subject.default_readers.size).to eq(3) }
  it { expect(subject.default_readers[0]).to be_a ParaDice::Results::SplitFaces }
  it { expect(subject.default_readers[1]).to be_a ParaDice::Results::CancelOpposing }
  it { expect(subject.default_readers[2]).to eq ParaDice::Results::Hash }

  describe '.get_cup' do
    let(:dice) { ['combat', 'combat', 'detect', 'crime', 'move', 'move', 'crime', 'combat'] }
    subject { described_class.get.get_cup(*dice) }
    it { expect(subject.roll!.size).to eq 8 }
  end
end
