require 'rspec'
require 'para_dice/die'
describe ParaDice::Die do
  before(:all) do
    class AbstractDie
      include ParaDice::Die
    end
  end

  let(:name) { 'fake_die' }
  subject { AbstractDie.new(name: name) }
  it { is_expected.to be_a ParaDice::Die }
  it { is_expected.to have_attributes(name: 'fake_die', description: '') }
  it { expect { subject.random_face }.to raise_error NotImplementedError, /random_face:/ }
  it { expect { subject.faces }.to raise_error NotImplementedError, /faces:/ }
  it { expect { subject.face_count }.to raise_error NotImplementedError, /face_count:/ }
  it 'will raise an error if no id is given to initializer' do
    expect { AbstractDie.new({}) }.to raise_error ArgumentError, /:name/
  end

end
