require 'rspec'
require 'para_dice/results/and_keep'

describe ParaDice::Results::AndKeep do
  let(:faces) { [2, 3, 4, 5] }
  subject { described_class.new.resolve(faces, 2) }
  it { is_expected.to eq [4, 5] }

  context 'with default_keep' do
    subject { described_class.new(2).resolve(faces) }
    it { is_expected.to eq [4, 5] }
  end

  context 'with a given keep' do
    subject { described_class.new(2).resolve(faces, 3) }
    it { is_expected.to eq [3, 4, 5] }
  end

  context 'keep from low values' do
    subject { described_class.new(2).resolve(faces, 2, true) }
    it { is_expected.to eq [2, 3] }

  end

  context 'given a sort_block' do
    let(:faces) { [[:z, 7], [:x, 3], [:y, 4]] }
    subject { described_class.new(3).resolve(faces) { |f| f.last } }
    it { is_expected.to eq [[:x, 3], [:y, 4], [:z, 7]] }
  end
end
