require 'rspec'
require 'para_dice/results/cancel_opposing'

describe ParaDice::Results::CancelOpposing do
  subject { described_class.new.resolve(faces, opposing) }
  let(:opposing) { [['foo', 'FOO'], ['bar', 'BAR'], ['blank', 'blank']] }

  context 'everything cancels' do
    let(:faces) { [:foo, :foo, :bar, :blank, :BAR, :BAR, :FOO, :bar, :FOO].map(&:to_s) }
    it { is_expected.to eq [] }
  end
  context 'partial cancellation' do
    let(:faces) { [:foo, :bar, :foo, :bar, :BAR, :FOO, :blank, :blank].map(&:to_s) }
    let(:expected_result) { ['foo', 'bar'] }

    it { is_expected.to eq expected_result }
  end
end
