require 'rspec'

require 'para_dice/results/number'

describe ParaDice::Results::Number do
  let(:faces) { [2, 3, 4] }
  subject { described_class.new }
  it { is_expected.to have_attributes(default_initial_value: 0, default_operator: :+) }
  describe 'ParaDice::Results::Number.revolve(faces, initial, operator)' do
    context 'with default values' do
      subject { described_class.new.resolve(faces) }

      it { is_expected.to eq 9 }
    end

    context 'given an initial value' do
      let(:initial) { 17 }
      subject { described_class.new(17).resolve(faces) }

      it { is_expected.to eq 26 }
    end

    context 'passed an initial value' do
      let(:initial) { 17 }
      subject { described_class.new(17).resolve(faces, 22) }

      it { is_expected.to eq 31 }
    end

    context 'given an initial value and operator' do
      let(:operator) { :* }
      let(:initial) { 1 }
      subject { described_class.new(initial, operator).resolve(faces) }

      it { is_expected.to eq 24 }

      describe 'another example' do
        let(:operator) { :- }
        let(:initial) { 100 }
        it { is_expected.to eq 91 }
      end
    end
  end
end
